﻿'****************************************** HELP
'RCK1.P_ProgramID (e.g. "4AD14721F3698705BA618E2C" )
'   * Activation Key encryption logic will depend on this key
'   * ProgramID Must have 24 Characters
'   * All Characters of ProgramID Must be 0 To 9 OR 'A' To 'F'
'
'RCK1.P_Sequence (e.g. "ABCDEFGHIJKLMNOPQRSTUVWXYZ" this is default value)
'   * for advance protection use this property otherwise not require
'   * Sequence String length Must be 26 characters
'   * All characters must be between ('A' to 'Z') OR (0 to 9)
'   * No character must repeat
'   * Here output character Key(Activation Code Or MID Code) is map as "A as A,B as B,
'       C as C....as on Z as Z". you can change maping value as per your requirement
'   * E.g.
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQ123456789"
'          RCK1.P_Sequence = "ZYXWVUTSRQPONMLKJIHGFEDCBA"
'
'RCK1.P_SoftwareID (e.g. 1 is Default value)
'   *   If you have more than 1 software use this property(if you changed P_ProgramID in
'       all your softwares then you don't set this property)
'   * SoftwareID Must Be Between 1 To 26
'   * E.g.
'           RCK1.P_SoftwareID = 1 (For School Software)
'           RCK1.P_SoftwareID = 2 (For Account Software)
'           RCK1.P_SoftwareID = 3 (For Payslip)
'
'############### NOTE ################
'IN DEMO VERSION
'YOU CAN NOT CHANGE VALUE OF FOLLOWING PROPERTY. VALUE OF FOLLOWING PROPERTY IS READONLY IN DEMO VERSION
'   RCK1.P_ProgramID = "0123456789ABCDEF01234567"
'   RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'   RCK1.P_SoftwareID = 1
'#####################################
Public Class FrmRegistrationForm
    Dim IsUnload As Boolean

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AppStatus = -100  ' For application status is demo
        RCK1.P_ProgramID = "0123456789ABCDEF01234567"       ' Activation Key encryption logic will depend on this key
        RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"      ' enter Sequence charactors. output character Key(Activation Code Or MID Code) is map as "A as A,B as B,C as C....as on Z as Z" but you can change this sequence by this parameter (e.g. ABCDEFGHIJKLMNOPQ123456789 )
        RCK1.P_SoftwareID = 1  ' 1 For School Software, 2 For Account Software, 3 For Payslip ...As on

        Dim MIDCode As String
        Dim ActivationCode As String
        Dim ExtraChar As String
        Dim ErrorNo As Integer
        '*** here we pass all hardware serial to Activation Code
        ExtraChar = GetHardwareInfo() ' this function return all hardware serial no
        ErrorNo = RCK1.P_GetMID3(MIDCode, ExtraChar)
        'Parameters description
        'MIDCode    -> Return MID Code (e.g. Return KLJEUQ-VHODR-SDGUS-VQAVB-FNDTM )
        'ExtraChar  -> Pass 20 characters of hardware Sr.no. as per your requirement
        '
        'this function return following error no
        'Return -1 For Width of ExtraChar(paramater) must be 20 character
        '       -2 For ExtraChar(parameter) value must be 'A' to 'Z'
        '        0 For MID Code created Success
        TxtMID.Text = MIDCode

        ActivationCode = RCK1.M_GetActCode3FromRCKLIC3_DLL(My.Application.Info.DirectoryPath)
        'Read Activation Code from (App.Path & "RCKLIC3.DLL")

        If ActivationCode <> "" Then
            Call CheckActivation(ActivationCode, False) ' Unprotect activation code
        End If
        IsUnload = False
        If AppStatus = 0 Then   ' if license copy
            Me.Width = 2
            Me.Height = 2
            Me.Top = -10
            Me.Left = -10
            IsUnload = True
        End If
    End Sub

    Private Sub FrmRegistrationForm_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        If IsUnload Then
            Me.Close()
        End If
    End Sub

    Private Sub CheckActivation(ByVal ActivationCode As String, ByVal IsDisplayMessage As Boolean)
        'this function unprotect activation code and match Hardware serial no to client PC
        'Parameter Description
        'ActivationCode     ->  Pass activation code
        'IsDisplayMessage   ->  Pass True for if you want to display error message

        Dim UniqueID As String = ""
        Dim SoftwareID As Integer
        Dim ExtraChar As String
        Dim ErrorNo As Integer
        Dim IsCreateRCKLIC3_DLL As Boolean
        IsCreateRCKLIC3_DLL = True

        ErrorNo = RCK1.M_UnprotectAct3(ActivationCode, SoftwareID, ExtraChar, My.Application.Info.DirectoryPath, IsCreateRCKLIC3_DLL)
        'Parameters description
        'ActivationCode                    -> Pass Activation Code (e.g.HKQTUVP-AHODR-SDGUS-VQAVB-FNDTM)
        'SoftwareID                        -> Return Software ID
        'ExtraChar                         -> Return Extra 20 characters Which you have passed when
        '                                     activation code is generated(which contains hardware
        '                                     Sr.no of client PC as per your requirement)
        'My.Application.Info.DirectoryPath -> Pass exe path (e.g. 'D:\School01') where it saves
        '                                     Activation Code in RCKLIC3.DLL file
        'IsCreateRCKLIC3_DLL               -> Pass True, if activation code successfully unprotect
        '                                     and then Activation code will save to (My.Application.Info.DirectoryPath & "RCKLIC3.DLL")
        '
        'Function return 0 For Activation Code unprotect Successfully

        If GetHardwareInfo() <> ExtraChar Then
            ErrorNo = -5
        End If
        If IsDisplayMessage Then
            Select Case ErrorNo
                Case -1
                    MsgBox("Width of Activation Code must be 27 characters", vbOKOnly + vbExclamation, "My App")
                Case -2
                    MsgBox("Every character of activation Code must be between 'A' to 'Z'", vbOKOnly + vbExclamation, "My App")
                    'As per your RCK1.SequenceNo
                    '(e.g. if RCK1.SequenceNo = 'ABCDEFGHIJKLMNOP0123456789' then 'A' to 'P' OR 0 TO 9 )
                Case -3
                    MsgBox("Invalid Activation Code(Typing mistake) or this Activation Code is not for this application ")
                Case -4
                    'SoftwareID(1 to 26) of Activation code is not match with SoftwareID of MID Code
                    MsgBox("Invalid Activation Code (Error -4)")
                Case -5
                    'Hardware Serial No of Activation Code does not match with Hardware Serial No of Client PC
                    MsgBox("Invalid Activation Code (Error -5)")
                Case 0
                    MsgBox("Successs")
            End Select
        End If
        '   AppStatus   -> 0            Activation Success (Registered copy)
        '   AppStatus   -> -1 to -5     error(Application status is Demo)
        '   AppStatus   -> -100         error(Application status is Demo)
        AppStatus = ErrorNo
        '***
    End Sub

    Private Function GetHardwareInfo() As String
        ' this function return hardware information
        ' Return (5 characters of Motherboard No)+(5 characters of HDD Serial No)+(5 characters of ProcessorID)+(5 characters of MAC Address),Total 20 characters return
        Dim ExtraCharacterPC
        ExtraCharacterPC = Microsoft.VisualBasic.Right(RCK1.M_GetMotherBoardSerialNo(), 5)
        ExtraCharacterPC = ExtraCharacterPC + Microsoft.VisualBasic.Right(RCK1.M_GetHDDDSerialNo(0, ""), 5)
        ExtraCharacterPC = ExtraCharacterPC + Microsoft.VisualBasic.Right(RCK1.M_GetProcessorId(), 5)
        ExtraCharacterPC = ExtraCharacterPC + Microsoft.VisualBasic.Right(RCK1.M_GetMacAddress(), 5)
        ExtraCharacterPC = Microsoft.VisualBasic.Left(ExtraCharacterPC, 20) ' pass only 20 character
        GetHardwareInfo = ExtraCharacterPC
    End Function

    Private Sub CmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOK.Click
        Call CheckActivation(TxtAct.Text, True)
        If AppStatus <> 0 Then
            Exit Sub
        End If
        Me.Close()
    End Sub

    Private Sub CmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdCancel.Click
        Me.Close()
    End Sub
End Class
